module Derivation where

data Derivation = Axiom
                | CP Int Int
                | Simp { original :: Int, rw_r :: [Int], rw_l :: [Int]  }
                | Goal { rw_r :: [Int], rw_l :: [Int] }

instance Show Derivation where
  show Axiom = "Proof: Axiom.\n"
  show (CP i1 i2)
    = "Proof: A critical pair between equations " ++ show i1 ++ " and " ++ show i2 ++ ".\n"
  show (Simp { original = orig, rw_r = rs, rw_l = ls})
    = "Proof: Rewrite equation " ++ show orig ++ ",\n" ++
      "               lhs with equations " ++ (show ls) ++ "\n" ++
      "               rhs with equations " ++ (show rs) ++ ".\n"
  show (Goal {rw_r = rs, rw_l = ls})
    = "Proof: Rewrite lhs with equations " ++ (show ls) ++ "\n" ++
      "               rhs with equations " ++ (show rs) ++ ".\n"
