{-# LANGUAGE NamedFieldPuns #-}
module E where

import Derivation
import PE

data E = E { eqn :: PE,
             eqn_id :: Int,
             eqn_derivation :: Derivation,
             active :: Bool }

instance Show E where
  show (E { eqn = (l, r), eqn_id = id, eqn_derivation = d  })
    = show id ++ ": "  ++ show l ++ " = " ++ show r ++ ".\n" ++
      show d

deactivate :: E -> E
deactivate (E { eqn = e, eqn_id = i, eqn_derivation = d})
  = E { eqn = e, eqn_id = i, eqn_derivation = d, active = False }

-- dependency of derivation
depE :: E -> [(Int, Int)]
depE (E {eqn_derivation = Axiom}) = []
depE (E {eqn_derivation = CP i1 i2, eqn_id = i })
  = [(i, i1), (i, i2)]
depE (E {eqn_derivation = Simp { original, rw_r, rw_l}, eqn_id = i})
  = (i, original) : [ (i, i') | i' <- rw_r ] ++ [ (i, i') | i' <- rw_l ]
depE (E {eqn_derivation = Goal { rw_r, rw_l }, eqn_id = i})
  = [ (i, i') | i' <- rw_r ] ++ [ (i, i') | i' <- rw_l ]
