module KBCompletion where

import Derivation
import E
import ES
import PE
import LPO
import Join
import Rewriting

-- NOTE: we cannot use list comprehension.
-- delete and simplify must be performed sequentially.
interreduce' :: Int -> Precedence -> ES -> ES -> ES -> (Int, ES, ES)
interreduce' next_id _ [] reduced deleted = (next_id, reduced, deleted)
interreduce' next_id prec (e : es) reduced deleted
  | not (active e)
    = interreduce' next_id prec es reduced (e : deleted)
  | groundJoinable prec es' l' r'
    = interreduce' next_id prec es reduced (deactivate e : deleted)
  | not (variant (l, r) (l', r'))
    = interreduce' (next_id+1) prec es  (e' : reduced) (deactivate e : deleted)
  | otherwise -- the case if (l, r) and (l', r') are variant.
              -- For example, no rewriting happened.
    = interreduce' next_id prec es (e : reduced) deleted
  where
    es' = reduced ++ es
    E { eqn = (l, r), eqn_id = eqn_id } = e
    gt_lpo = gtLPO prec
    (l_ids, l') = nf es' gt_lpo l
    (r_ids, r') = nf es' gt_lpo r
    deriv = Simp { original = eqn_id, rw_r = r_ids, rw_l = l_ids }
    e' = E { eqn = (l', r'),
             eqn_id = next_id,
             eqn_derivation = deriv,
             active = True }

-- args: (E, >)
-- performs "simplify" and "delete"
-- returns (next_id, reduced, deleted)
interreduce :: Int -> Precedence -> ES -> (Int, ES, ES)
interreduce next_id prec es = interreduce' next_id prec es [] []
